#ifndef __TOP_H
#define __TOP_H

#include <systemc.h>

#include "mod.h"
#include "test_bench.h"

SC_MODULE( TOP )
{
    sc_in_clk          clk;
    sc_signal<bool>    reset_n;

    sc_signal<bool>           in_en;
    sc_signal<unsigned long>  in_A;
    sc_signal<unsigned long>  in_B;

    sc_signal<bool>           out_en;
    sc_signal<unsigned long>  out_P;

    MOD         *uMOD;
    TEST_BENCH  *uTEST_BENCH;

    SC_CTOR( TOP )
    {
        uMOD = new MOD( "uMOD" );
        uMOD->clk( clk );
        uMOD->reset_n( reset_n );
        uMOD->in_en( in_en );
        uMOD->in_A( in_A );
        uMOD->in_B( in_B );
        uMOD->out_P( out_P );
        uMOD->out_en( out_en );

        uTEST_BENCH = new TEST_BENCH( "uTEST_BENCH" );
        uTEST_BENCH->clk( clk );
        uTEST_BENCH->reset_n( reset_n );
        uTEST_BENCH->in_en( in_en );
        uTEST_BENCH->in_A( in_A );
        uTEST_BENCH->in_B( in_B );
        uTEST_BENCH->out_P( out_P );
        uTEST_BENCH->out_en( out_en );
    }
    ~TOP()
    {
        delete uMOD;
        delete uTEST_BENCH;
    }

};

#endif /* __TOP_H */
